"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Data = void 0;
const api_1 = require("./api");
const utils_1 = require("@ztimson/utils");
class Data extends utils_1.TypedEmitter {
    api;
    constructor(api) {
        super();
        this.api = typeof api == 'string' ? new api_1.Api(api) : api;
    }
    delete(collection, document) {
        return this.api.request({
            url: `/api/data/${collection}/${document}`,
            method: 'DELETE'
        }).then(() => this.emit('DELETE', collection, document));
    }
    get(collection, document) {
        return this.api.request({ url: `/api/data/${collection}${document ? `/${document}` : ''}` }).then(resp => {
            this.emit('GET', collection, resp);
            return resp;
        });
    }
    raw(collection, operand, query, options) {
        return this.api.request({
            url: `/api/data/${collection}`,
            body: {
                operand,
                query,
                options,
            }
        }).then(resp => {
            this.emit('RAW', collection, resp);
            return resp;
        });
    }
    set(collection, document, append = false) {
        return this.api.request({
            url: `/api/data/${collection}/${document._id || ''}`,
            method: append ? 'PATCH' : 'POST',
            body: document
        }).then(resp => {
            this.emit('SET', collection, document);
            return resp;
        });
    }
}
exports.Data = Data;
