"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Email = void 0;
const api_1 = require("./api");
const utils_1 = require("@ztimson/utils");
class Email extends utils_1.TypedEmitter {
    api;
    constructor(api) {
        super();
        this.api = typeof api == 'string' ? new api_1.Api(api) : api;
    }
    send(email) {
        let url = '/api/email';
        if (typeof email.body == 'object')
            url += `/${email.body.template}`;
        return this.api.request({ url, body: email }).then(resp => {
            this.emit('SENT', email);
            return resp;
        });
    }
}
exports.Email = Email;
