import { Actions } from './actions';
import { Api, type ApiEvents } from './api';
import { Auth, type AuthEvents, AuthOptions } from './auth';
import { Data, type DataEvents } from './data';
import { Email, type EmailEvents } from './email';
import { Groups } from './groups';
import { TypedEmitter, type TypedEvents, type XhrOptions } from '@ztimson/utils';
import { Logger, LogLevel } from './logger';
import { Pdf, type PdfEvents } from './pdf';
import { Socket } from './sockets';
import { Storage, type StorageEvents } from './storage';
import { Users } from './users';
import { Settings, type SettingEvents } from './settings';
import { Static, type StaticEvents } from './static';
export type MomentumEvents = TypedEvents & ApiEvents & AuthEvents & DataEvents & EmailEvents & PdfEvents & StaticEvents & StorageEvents & SettingEvents;
export type MomentumOptions = AuthOptions & {
    logLevel?: LogLevel;
    socket?: boolean;
    api?: XhrOptions;
};
export declare class Momentum extends TypedEmitter<MomentumEvents> {
    api: Api;
    actions: Actions;
    auth: Auth;
    data: Data;
    email: Email;
    groups: Groups;
    logger: Logger;
    pdf: Pdf;
    settings: Settings;
    socket?: Socket;
    static: Static;
    storage: Storage;
    users: Users;
    constructor(url?: string, opts?: MomentumOptions);
}
//# sourceMappingURL=momentum.d.ts.map