"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Static = void 0;
const api_1 = require("./api");
const utils_1 = require("@ztimson/utils");
class Static extends utils_1.TypedEmitter {
    api;
    constructor(api) {
        super();
        this.api = typeof api == 'string' ? new api_1.Api(api) : api;
    }
    delete(path) {
        return this.api.request({ url: `/api/static/${path}`, method: 'DELETE' }).then(() => {
            this.emit('DELETE', path);
        });
    }
    list(path) {
        const url = ('/api/static/' + path).replaceAll('//', '/');
        return this.api.request({ url }).then(resp => {
            this.emit('LIST', path, resp);
            return resp;
        });
    }
    upload(files, path = '/') {
        const data = new FormData();
        (Array.isArray(files) ? files : [files]).forEach(f => data.append('file', f));
        return this.api.request({ url: '/api/static' + path, body: data }).then(resp => {
            this.emit('UPLOAD', resp);
            return resp;
        });
    }
}
exports.Static = Static;
