import { Api } from './api';
import { TypedEmitter, type TypedEvents } from '@ztimson/utils';
import { BehaviorSubject } from 'rxjs';
import type { Meta } from './core';
export type User = Meta & {
    username: string;
    name: string;
    email: string;
    image: string;
    disabled?: boolean;
    groups: string[];
    permissions: string[];
    notes: string;
    custom?: any;
    lastLogin?: number | null;
    totp?: false | 'app' | 'email' | 'phone';
};
export type UserEvents = TypedEvents & {
    LIST: (users: User[]) => any;
    READ: (user: User) => any;
    UPDATE: (user: User) => any;
    DELETE: (username: string) => any;
    UPLOAD_IMAGE: (file: File) => any;
};
export declare class Users extends TypedEmitter<UserEvents> {
    private readonly api;
    private listed;
    $cache: BehaviorSubject<User[]>;
    get cache(): User[];
    set cache(val: User[]);
    constructor(api: Api | string);
    delete(username: string): Promise<void>;
    list(reload?: boolean): Promise<User[]>;
    read(username: string, reload?: boolean): Promise<User>;
    update(user: User): Promise<User>;
    uploadImage(username: string, file: File): Promise<unknown>;
}
//# sourceMappingURL=users.d.ts.map